#include "cbs.h"

#include <aquosa/qres_lib.h>
#include <stdint.h>
#include <stdio.h>

#include "lfs_threads.h"

int cbs_init(void) {
  qos_chk_ok_exit(qres_init());
  return 0;
}

int cbs_get(int pid, uint32_t *q, uint32_t *p, int *l)
{
  qres_sid_t sid;
  qres_params_t params;

  qos_chk_ok_exit(qres_get_sid(pid, pid, &sid));
  qos_chk_ok_exit(qres_get_params(sid, &params));

  *q = params.Q;
  *p = params.P;

/*   err = ce.deadline - ce.t; */
/*   *l = err / 1000; */

//fprintf(stderr, "%d Read %u %u %d %Ld (=%Lu - %Lu)\n", pid, *q, *p, *l, err / 1000, ce.deadline, ce.t);
  
  return 0;
}

/* int32_t cbs_howlate(int pid) */
/* { */
/*   int res; */
/*   struct sched_param sp; */
/*   struct cbs_error ce; */

/*   sp.sched_size = sizeof(struct cbs_error); */
/*   sp.sched_p = &ce; */
/*   ce.signature = E_SIGNATURE; */
/*   res = sched_getparam(pid, &sp); */
/*   if (res < 0) { */
/*     fprintf(stderr, "Cannot get the scheduling error!!!\n"); */
/*     return ~0; */
/*   } */

/*   return ce.deadline - ce.t; */
/* } */

int cbs_transform(uint32_t q, uint32_t t) {
  struct qres_params_t params;
  qres_sid_t sid;
  int i;

  params.Q_min = 0;
  params.Q = q;
  params.P = t;
  params.flags = 0;
  qos_log_debug("Creating server with Q=%d P=%d", q, t);
  qos_chk_ok_exit(qres_create_server(&params, &sid));

  for (i = 0; i < num_threads; ++i) {
    qos_log_debug("Attaching to sid %d thread %d", sid, threads[i]);
    qos_chk_ok_exit(qres_attach_thread(sid, threads[i], threads[i]));
  }

  return 0;
}

int cbs_set(int pid, uint32_t q, uint32_t t)
{
  qres_sid_t sid;
  struct qres_params_t params;
  params.Q_min = 0;
  params.Q = q;
  params.P = t;
  qos_chk_ok_exit(qres_get_sid(pid, pid, &sid));
  qos_chk_ok_exit(qres_set_params(sid, &params));
  return 0;
}
